<?php

namespace App\Controller;

use App\Service\S3Service;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Symfony\Component\HttpFoundation\Response;
use Symfony\Component\HttpKernel\Attribute\AsController;
use Symfony\Component\Routing\Annotation\Route;

#[AsController]
class FileController
{
    #[Route('/download/{fileName}', name: 'download_file', requirements: ['fileName' => '.*'], methods: ['GET'])]
    public function downloadFile(S3Service $s3Service, string $fileName): Response
    {
        if (!$s3Service->checkIfFileExists('download/' . $fileName)) {
            return new Response('File not found', 404);
        }
        $signedURL = $s3Service->generateSignedUrl('download/' . $fileName);
        return new RedirectResponse($signedURL);
    }

    #[Route('/img/{fileName}', name: 'download_image', requirements: ['fileName' => '.*'], methods: ['GET'])]
    public function downloadImage(S3Service $s3Service, string $fileName): Response
    {
        if (!$s3Service->checkIfFileExists('img/' . $fileName)) {
            return new Response('File not found', 404);
        }
        $signedURL = $s3Service->generateSignedUrl('img/' . $fileName);
        return new RedirectResponse($signedURL);
    }
}
