<?php

namespace App\Service;

class ImgProxyService
{
    public function __construct(
        private string $imgProxySalt,
        private string $imgProxyKey,
        private string $imgProxyUrl,
        private int $imgDefaultWidth,
    ) {
    }

    public function generateURL(string $imageURL, int $imageWidth = null): string
    {
        if (!$imageWidth) {
            $imageWidth = $this->imgDefaultWidth;
        }

        $encodedUrl = rtrim(strtr(base64_encode($imageURL), '+/', '-_'), '=');
        $path = "/rs:fit:0:$imageWidth:1/g:no/{$encodedUrl}.webp";

        $signature = rtrim(
            strtr(
                base64_encode(
                    hash_hmac('sha256', $this->imgProxySalt . $path, $this->imgProxyKey, true)
                ),
                '+/',
                '-_'
            ),
            '='
        );
        return $this->imgProxyUrl . "/" . $signature . $path;
    }
}
