<?php

namespace App\Service;

use Parsedown;

class MarkdownService extends Parsedown
{
    public function __construct(
        private ImgProxyService $imgProxyService,
        private S3Service $s3Service,
    ) {
    }

    # @phpstan-ignore-next-line
    protected function inlineImage($Excerpt)
    {
        $image = parent::inlineImage($Excerpt);
        if (!$image) {
            return null;
        }
        $Excerpt['text'] = substr($Excerpt['text'], 1);
        $link = $this->inlineLink($Excerpt);

        if (str_starts_with($image['element']['attributes']['src'], '/img')) {
            $imageURL = $this->s3Service->generateSignedUrl($image['element']['attributes']['src']);
        } else {
            $imageURL = $image['element']['attributes']['src'];
        }
        $image['element']['attributes']['src'] = $this->imgProxyService->generateURL($imageURL);

        unset($link['element']['handler']);
        unset($link['element']['nonNestables']);
        $link['element']['handler'] = 'element';
        $link['element']['text'] = $image['element'];
        $link['extent'] += 1;

        return $link;
    }
}
