<?php

namespace App\Twig\Components;

use App\Entity\Blog;
use App\Repository\BlogRepository;
use Symfony\UX\TwigComponent\Attribute\AsTwigComponent;
use Symfony\UX\TwigComponent\Attribute\PreMount;

#[AsTwigComponent('blog_preview')]
final class BlogPreviewComponent
{
    public int $id;
    public Blog $blog;
    public function __construct(private BlogRepository $blogRepository)
    {
    }

    /**
     * @param array<string, mixed> $data
     * @return array<string, mixed>
     */
    #[PreMount]
    public function preMount(array $data): array
    {
        $this->blog = $this->blogRepository->find($data['id']);
        return $data;
    }

    public function getTitle(): string
    {
        return $this->blog->getTitle();
    }

    public function getContent(): string
    {
        return  $this->blog->getContent();
    }

    public function getId(): int
    {
        return $this->blog->getId();
    }
}
