<?php

namespace App\Tests\Service;

use PHPUnit\Framework\TestCase;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\RequestStack;
use Symfony\Component\HttpFoundation\Session\Session;
use Symfony\Component\HttpFoundation\Session\Storage\MockArraySessionStorage;

class CaptchaServiceTest extends TestCase
{
    private \App\Service\CaptchaService $captchaService;
    private RequestStack $requestStack;
    public function setUp(): void
    {
        parent::setUp();

        $this->requestStack = new RequestStack();
        $request = new Request();
        $session = new Session(new MockArraySessionStorage());
        $request->setSession($session);
        $this->requestStack->push($request);

        $this->captchaService = new \App\Service\CaptchaService($this->requestStack);
    }

    public function testInlineCaptcha(): void
    {
        $this->assertStringContainsString('data:image/', $this->captchaService->getInlineCaptcha());
    }

    public function testSetCaptchaCodeInSession()
    {
        $this->captchaService->getInlineCaptcha();
        $this->assertNotEmpty($this->requestStack->getSession()->get('captcha'));
    }

    public function testValidateCaptcha()
    {
        $this->captchaService->getInlineCaptcha();
        $this->assertTrue($this->captchaService->validate($this->requestStack->getSession()->get('captcha')));
    }
}
